package edu.mermet.tp8.aide;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.KeyStroke;

import edu.mermet.tp8.Application;

public class ConfigurationMenus extends JDialog {
	
	Application application;
	
	//tableau radio buttons
	JPanel tableauRadio;
	//diapo
	JLabel conversionLabel;
	ButtonGroup conversionRadio;
	JRadioButton conversionRadioAuto;
	JRadioButton conversionRadioAffiche;
	JRadioButton conversionRadioCache;
	//Saisie de texte
	JLabel texteLabel;
	ButtonGroup texteRadio;
	JRadioButton texteRadioAuto;
	JRadioButton texteRadioAffiche;
	JRadioButton texteRadioCache;
	//Diaporama
	JLabel diapoLabel;
	ButtonGroup diapoRadio;
	JRadioButton diapoRadioAuto;
	JRadioButton diapoRadioAffiche;
	JRadioButton diapoRadioCache;
	//Boutons
	JLabel boutonsLabel;
	ButtonGroup boutonsRadio;
	JRadioButton boutonsRadioAuto;
	JRadioButton boutonsRadioAffiche;
	JRadioButton boutonsRadioCache;

	//Barre de boutons
	JPanel boutons;
	JButton boutonValider;
	JButton boutonAnnuler;
	
	public ConfigurationMenus(Application application) {
		super(application, true);
		this.application = application;
		init();
		setTitle("Configuration des menus");
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private void init() {
		tableauRadio = new JPanel(new GridLayout(4,4));
		
		conversionLabel = new JLabel("conversion Celsius/Frenheit");
		tableauRadio.add(conversionLabel);
		conversionRadio = new ButtonGroup();
		conversionRadioAuto = new JRadioButton("Auto");
		conversionRadioAuto.setActionCommand("" + Application.MENU_MODE_AUTO);
		conversionRadio.add(conversionRadioAuto);
		tableauRadio.add(conversionRadioAuto);
		conversionRadioAffiche = new JRadioButton("Affiché");
		conversionRadioAffiche.setActionCommand("" + Application.MENU_MODE_AFFICHE);
		conversionRadio.add(conversionRadioAffiche);
		tableauRadio.add(conversionRadioAffiche);
		conversionRadioCache = new JRadioButton("Caché");
		conversionRadioCache.setActionCommand("" + Application.MENU_MODE_CACHE);
		conversionRadio.add(conversionRadioCache);
		tableauRadio.add(conversionRadioCache);
		
		texteLabel = new JLabel("texte Celsius/Frenheit");
		tableauRadio.add(texteLabel);
		texteRadio = new ButtonGroup();
		texteRadioAuto = new JRadioButton("Auto");
		texteRadioAuto.setActionCommand("" + Application.MENU_MODE_AUTO);
		texteRadio.add(texteRadioAuto);
		tableauRadio.add(texteRadioAuto);
		texteRadioAffiche = new JRadioButton("Affiché");
		texteRadioAffiche.setActionCommand("" + Application.MENU_MODE_AFFICHE);
		texteRadio.add(texteRadioAffiche);
		tableauRadio.add(texteRadioAffiche);
		texteRadioCache = new JRadioButton("Caché");
		texteRadioCache.setActionCommand("" + Application.MENU_MODE_CACHE);
		texteRadio.add(texteRadioCache);
		tableauRadio.add(texteRadioCache);
		
		diapoLabel = new JLabel("diapo Celsius/Frenheit");
		tableauRadio.add(diapoLabel);
		diapoRadio = new ButtonGroup();
		diapoRadioAuto = new JRadioButton("Auto");
		diapoRadioAuto.setActionCommand("" + Application.MENU_MODE_AUTO);
		diapoRadio.add(diapoRadioAuto);
		tableauRadio.add(diapoRadioAuto);
		diapoRadioAffiche = new JRadioButton("Affiché");
		diapoRadioAffiche.setActionCommand("" + Application.MENU_MODE_AFFICHE);
		diapoRadio.add(diapoRadioAffiche);
		tableauRadio.add(diapoRadioAffiche);
		diapoRadioCache = new JRadioButton("Caché");
		diapoRadioCache.setActionCommand("" + Application.MENU_MODE_CACHE);
		diapoRadio.add(diapoRadioCache);
		tableauRadio.add(diapoRadioCache);
		
		boutonsLabel = new JLabel("boutons Celsius/Frenheit");
		tableauRadio.add(boutonsLabel);
		boutonsRadio = new ButtonGroup();
		boutonsRadioAuto = new JRadioButton("Auto");
		boutonsRadioAuto.setActionCommand("" + Application.MENU_MODE_AUTO);
		boutonsRadio.add(boutonsRadioAuto);
		tableauRadio.add(boutonsRadioAuto);
		boutonsRadioAffiche = new JRadioButton("Affiché");
		boutonsRadioAffiche.setActionCommand("" + Application.MENU_MODE_AFFICHE);
		boutonsRadio.add(boutonsRadioAffiche);
		tableauRadio.add(boutonsRadioAffiche);
		boutonsRadioCache = new JRadioButton("Caché");
		boutonsRadioCache.setActionCommand("" + Application.MENU_MODE_CACHE);
		boutonsRadio.add(boutonsRadioCache);
		tableauRadio.add(boutonsRadioCache);
		
		preSelectRadioButtons();
		add(tableauRadio, BorderLayout.CENTER);
		
		boutons = new JPanel();
		boutonValider = new JButton(new ActionValider());
		boutons.add(boutonValider);
		boutonAnnuler = new JButton(new ActionAnnuler());
		boutons.add(boutonAnnuler);
		add(boutons, BorderLayout.SOUTH);
	}
	
	private void preSelectRadioButtons() {
		switch(application.getConversionMenuMode()) {
		case Application.MENU_MODE_AUTO:
			conversionRadioAuto.setSelected(true);
			break;
		case Application.MENU_MODE_AFFICHE:
			conversionRadioAffiche.setSelected(true);
			break;
		case Application.MENU_MODE_CACHE:
			conversionRadioCache.setSelected(true);
			break;
		default:
			conversionRadioAuto.setSelected(true);
		}
		switch(application.getTexteMenuMode()) {
		case Application.MENU_MODE_AUTO:
			texteRadioAuto.setSelected(true);
			break;
		case Application.MENU_MODE_AFFICHE:
			texteRadioAffiche.setSelected(true);
			break;
		case Application.MENU_MODE_CACHE:
			texteRadioCache.setSelected(true);
			break;
		default:
			texteRadioAuto.setSelected(true);
		}
		switch(application.getDiapoMenuMode()) {
		case Application.MENU_MODE_AUTO:
			diapoRadioAuto.setSelected(true);
			break;
		case Application.MENU_MODE_AFFICHE:
			diapoRadioAffiche.setSelected(true);
			break;
		case Application.MENU_MODE_CACHE:
			diapoRadioCache.setSelected(true);
			break;
		default:
			diapoRadioAuto.setSelected(true);
		}
		switch(application.getBoutonsMenuMode()) {
		case Application.MENU_MODE_AUTO:
			boutonsRadioAuto.setSelected(true);
			break;
		case Application.MENU_MODE_AFFICHE:
			boutonsRadioAffiche.setSelected(true);
			break;
		case Application.MENU_MODE_CACHE:
			boutonsRadioCache.setSelected(true);
			break;
		default:
			boutonsRadioAuto.setSelected(true);
		}
	}
	
    private class ActionValider extends AbstractAction {
        public ActionValider() {
            super("Valider");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
        	System.out.println(Integer.parseInt(conversionRadio.getSelection().getActionCommand()) + conversionRadio.getSelection().getActionCommand());
            application.setConversionMenuMode(Integer.parseInt(conversionRadio.getSelection().getActionCommand()));
            application.setTexteMenuMode(Integer.parseInt(texteRadio.getSelection().getActionCommand()));
            application.setDiapoMenuMode(Integer.parseInt(diapoRadio.getSelection().getActionCommand()));
            application.setBoutonsMenuMode(Integer.parseInt(boutonsRadio.getSelection().getActionCommand()));
            application.refreshMenuMode();
            dispose();
        }
    }
    
    private class ActionAnnuler extends AbstractAction {
        public ActionAnnuler() {
            super("Annuler");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            dispose();
        }
    }
}
